Main Page Widgets Namespaces Book

# Gtk::TextIter Class Reference
[TextView Classes]

List of all members.

## Detailed Description

Typefed as Gtk::TextBuffer::iterator.

An iterator represents a position between two characters in the text buffer. Iterators are not valid indefinitely; whenever the buffer is modified in a way that affects the number of characters in the buffer, all outstanding iterators become invalid. (Note that deleting 5 characters and then reinserting 5 still invalidates iterators, though you end up with the same number of characters you pass through a state with a different number).

Because of this, iterators can't be used to preserve positions across buffer modifications. To preserve a position, the Gtk::TextBuffer::Mark object is ideal.

You can iterate over characters, words, lines, and sentences, but operator*() and operator++() deal only in characters.

## Public Types

typedef int | difference_type
typedef std::bidirectional_iterator_tag | iterator_category
typedef void | pointer
typedef value_type | reference
typedef gunichar | value_type

## Public Member Functions

bool | backward_char ()
| Moves backward by one character offset.
bool | backward_chars (int count)
| Moves count characters backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_cursor_position ()
| Like gtk_text_iter_forward_cursor_position(), but moves backward.
bool | backward_cursor_positions (int count)
| Moves up to count cursor positions.
template<class Predicate>
bool | backward_find_char (const Predicate& predicate)
template<class Predicate>
bool | backward_find_char (const Predicate& predicate, const TextIter& limit)
bool | backward_line ()
| Moves iter to the start of the previous line.
bool | backward_lines (int count)
| Moves count lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end) const
| Same as backward_search(), but searches to the start.
bool | backward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end, const TextIter& limit) const
| Same as gtk_text_iter_forward_search(), but moves backward.
bool | backward_sentence_start ()
| Moves backward to the previous sentence start; if iter is already at the start of a sentence, moves backward to the next one.
bool | backward_sentence_starts (int count)
| Calls gtk_text_iter_backward_sentence_start() up to count times, or until it returns `false`.
bool | backward_to_tag_toggle (const Glib::RefPtr<TextTag>& tag)
| Moves backward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.
bool | backward_visible_cursor_position ()
| Moves iter forward to the previous visible cursor position.
bool | backward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
bool | backward_visible_line ()
| Moves iter to the start of the previous visible line.
bool | backward_visible_lines (int count)
| Moves count visible lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | backward_visible_word_start ()
| Moves backward to the previous visible word start.
bool | backward_visible_word_starts (int count)
| Calls gtk_text_iter_backward_visible_word_start() up to count times.
bool | backward_word_start ()
| Moves backward to the previous word start.
bool | backward_word_starts (int count)
| Calls gtk_text_iter_backward_word_start() up to count times.
bool | begins_tag () const
bool | begins_tag (const Glib::RefPtr<const TextTag>& tag) const
| Return value: whether iter is the start of a range tagged with tag.
bool | can_insert (bool default_editability=true) const
| Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.
int | compare (const TextIter& rhs) const
| A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they're equal.
bool | editable (bool default_setting=true) const
| Return value: whether iter is inside an editable range.
bool | ends_line () const
| Return value: whether iter is at the end of a line.
bool | ends_sentence () const
| Determines whether iter ends a sentence.
bool | ends_tag () const
bool | ends_tag (const Glib::RefPtr<const TextTag>& tag) const
| Return value: whether iter is the end of a range tagged with tag.
bool | ends_word () const
| Determines whether iter ends a natural-language word.
bool | forward_char ()
| Moves iter forward by one character offset.
bool | forward_chars (int count)
| Moves count characters if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_cursor_position ()
| Moves iter forward by a single cursor position.
bool | forward_cursor_positions (int count)
| Moves up to count cursor positions.
template<class Predicate>
bool | forward_find_char (const Predicate& predicate)
template<class Predicate>
bool | forward_find_char (const Predicate& predicate, const TextIter& limit)
bool | forward_line ()
| Moves iter to the start of the next line.
bool | forward_lines (int count)
| Moves count lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end) const
| Same as forward_search(), but searchs to the end.
bool | forward_search (const Glib::ustring& str, TextSearchFlags flags, TextIter& match_start, TextIter& match_end, const TextIter& limit) const
| Searches forward for str.
bool | forward_sentence_end ()
| Moves forward to the next sentence end.
bool | forward_sentence_ends (int count)
| Calls gtk_text_iter_forward_sentence_end() count times (or until gtk_text_iter_forward_sentence_end() returns `false`).
void | forward_to_end ()
| Moves iter forward to the "end iterator," which points one past the last valid character in the buffer.
bool | forward_to_line_end ()
| Moves the iterator to point to the paragraph delimiter characters, which will be either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character.
bool | forward_to_tag_toggle (const Glib::RefPtr<TextTag>& tag)
| Moves forward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.
bool | forward_visible_cursor_position ()
| Moves iter forward to the next visible cursor position.
bool | forward_visible_cursor_positions (int count)
| Moves up to count visible cursor positions.
bool | forward_visible_line (int count)
| Moves count visible lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).
bool | forward_visible_line ()
| Moves iter to the start of the next visible line.
bool | forward_visible_word_end ()
| Moves forward to the next visible word end.
bool | forward_visible_word_ends (int count)
| Calls gtk_text_iter_forward_visible_word_end() up to count times.
bool | forward_word_end ()
| Moves forward to the next word end.
bool | forward_word_ends (int count)
| Calls gtk_text_iter_forward_word_end() up to count times.
bool | get_attributes (TextAttributes& values) const
Glib::RefPtr<TextBuffer> | get_buffer () const
| Return value: the buffer.
int | get_bytes_in_line () const
| Return value: number of bytes in the line.
gunichar | get_char () const
| returns 0.
int | get_chars_in_line () const
| Return value: number of characters in the line.
Glib::RefPtr< const TextChildAnchor > | get_child_anchor () const
| If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).
Glib::RefPtr<TextChildAnchor> | get_child_anchor ()
| If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).
Pango::Language | get_language () const
| A convenience wrapper around gtk_text_iter_get_attributes(), which returns the language in effect at iter.
int | get_line () const
| Return value: a line number.
int | get_line_index () const
| Return value: distance from start of line, in bytes.
int | get_line_offset () const
| Return value: offset from start of line.
Glib::SListHandle <Glib::RefPtr<const TextMark>> | get_marks () const
| Return value: list of Gtk::TextMark.
Glib::SListHandle <Glib::RefPtr<TextMark>> | get_marks ()
| Return value: list of Gtk::TextMark.
int | get_offset () const
| Return value: a character offset.
Glib::RefPtr<Gdk::Pixbuf> | get_pixbuf () const
| If the element at iter is a pixbuf, the pixbuf is returned (with no new reference count added).
Glib::ustring | get_slice (const TextIter& end) const
| Return value: slice of text from the buffer.
Glib::SListHandle <Glib::RefPtr<const TextTag>> | get_tags () const
| Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).
Glib::SListHandle <Glib::RefPtr<TextTag>> | get_tags ()
| Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).
Glib::ustring | get_text (const TextIter& end) const
| Return value: array of characters from the buffer.
Glib::SListHandle <Glib::RefPtr<const TextTag>> | get_toggled_tags (bool toggled_on=true) const
| Return value: tags toggled at this point.
Glib::SListHandle <Glib::RefPtr<TextTag>> | get_toggled_tags (bool toggled_on=true)
| Return value: tags toggled at this point.
int | get_visible_line_index () const
| Return value: byte index of iter with respect to the start of the line.
int | get_visible_line_offset () const
| Return value: offset in visible characters from the start of the line.
Glib::ustring | get_visible_slice (const TextIter& end) const
| Like gtk_text_iter_get_slice(), but invisible text is not included.
Glib::ustring | get_visible_text (const TextIter& end) const
| Like gtk_text_iter_get_text(), but invisible text is not included.
const GtkTextIter* | gobj () const
| Provides access to the underlying C instance.
GtkTextIter* | gobj ()
| Provides access to the underlying C instance.
bool | has_tag () const
bool | has_tag (const Glib::RefPtr<const TextTag>& tag) const
| Return value: whether iter is tagged with tag.
bool | in_range (const TextIter& start, const TextIter& end) const
| Checks whether iter falls in the range [ start, end).
bool | inside_sentence () const
| Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).
bool | inside_word () const
| Determines whether iter is inside a natural-language word (as opposed to say inside some whitespace).
bool | is_cursor_position () const
| See gtk_text_iter_forward_cursor_position() or Pango::LogAttr or pango_break() for details on what a cursor position is.
bool | is_end () const
| Return value: whether iter is the end iterator.
bool | is_start () const
| Return value: whether iter is the first in the buffer.
| operator bool () const
| Alias for !is_end().
value_type | operator* () const
| Alias for get_char().
const TextIter | operator++ (int)
TextIter& | operator++ ()
| Alias for forward_char().
const TextIter | operator-- (int)
TextIter& | operator-- ()
| Alias for backward_char().
void | order (TextIter& second)
| Swaps the value of first and second if second comes before first in the buffer.
void | set_line (int line_number)
| Moves iterator iter to the start of the line line_number.
void | set_line_index (int byte_on_line)
| Same as gtk_text_iter_set_line_offset(), but works with a byte index.
void | set_line_offset (int char_on_line)
| Moves iter within a line, to a new character (not byte) offset.
void | set_offset (int char_offset)
| Sets iter to point to char_offset.
void | set_visible_line_index (int byte_on_line)
| Like gtk_text_iter_set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.
void | set_visible_line_offset (int char_on_line)
| Like gtk_text_iter_set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.
bool | starts_line () const
| Return value: whether iter begins a line.
bool | starts_sentence () const
| Determines whether iter begins a sentence.
bool | starts_word () const
| Determines whether iter begins a natural-language word.
| TextIter (const GtkTextIter* gobject)
| TextIter ()
bool | toggles_tag () const
bool | toggles_tag (const Glib::RefPtr<const TextTag>& tag) const
| This is equivalent to (gtk_text_iter_begins_tag() || gtk_text_iter_ends_tag()), i.e. it tells you whether a range with tag applied to it begins or ends at iter.

## Protected Attributes

GtkTextIter | gobject_

## Related Functions

(Note that these are not member functions.)
bool | operator!= (const TextIter& lhs, const TextIter& rhs)
bool | operator< (const TextIter& lhs, const TextIter& rhs)
bool | operator<= (const TextIter& lhs, const TextIter& rhs)
bool | operator== (const TextIter& lhs, const TextIter& rhs)
bool | operator> (const TextIter& lhs, const TextIter& rhs)
bool | operator>= (const TextIter& lhs, const TextIter& rhs)
const Gtk::TextIter& | wrap (const GtkTextIter* object)
Gtk::TextIter& | wrap (GtkTextIter* object)

## Member Typedef Documentation

typedef int Gtk::TextIter::difference_type

typedef std::bidirectional_iterator_tag Gtk::TextIter::iterator_category

typedef void Gtk::TextIter::pointer

typedef value_type Gtk::TextIter::reference

typedef gunichar Gtk::TextIter::value_type

## Constructor & Destructor Documentation

Gtk::TextIter::TextIter | ( |  | ) |

Gtk::TextIter::TextIter | ( | const GtkTextIter * | gobject | ) | `[explicit]`

## Member Function Documentation

bool Gtk::TextIter::backward_char | ( |  | ) |

Moves backward by one character offset.

Returns `true` if movement was possible; if iter was the first in the buffer (character offset 0), gtk_text_iter_backward_char() returns `false` for convenience when writing loops.

Returns:
  Whether movement was possible.

bool Gtk::TextIter::backward_chars | ( | int | count | ) |

Moves count characters backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`.

Parameters:

  | count | Number of characters to move.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::backward_cursor_position | ( |  | ) |

Like gtk_text_iter_forward_cursor_position(), but moves backward.

Returns:
  `true` if we moved.

bool Gtk::TextIter::backward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See gtk_text_iter_forward_cursor_position() for details.

Parameters:

  | count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

template <class Predicate>

bool Gtk::TextIter::backward_find_char | ( | const Predicate & | predicate | ) | `[inline]`

template <class Predicate>

bool Gtk::TextIter::backward_find_char | ( | const Predicate & | predicate,
|  | const TextIter& | limit |
| ) |  |  | `[inline]`

bool Gtk::TextIter::backward_line | ( |  | ) |

Moves iter to the start of the previous line.

Returns `true` if iter could be moved; i.e. if iter was at character offset 0, this function returns `false`. Therefore if iter was already on line 0, but not at the start of the line, iter is snapped to the start of the line and the function returns `true`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

Returns:
  Whether iter moved.

bool Gtk::TextIter::backward_lines | ( | int | count | ) |

Moves count lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves forward by 0 - count lines.

Parameters:

  | count | Number of lines to move backward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::backward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end |
| ) |  |  | const

Same as backward_search(), but searches to the start.

Parameters:

  | str | Search string.
  | flags | Bitmask of flags affecting the search.
  | match_start | Return location for start of match, or `0`.
  | match_end | Return location for end of match, or `0`.

Returns:
  Whether a match was found.

bool Gtk::TextIter::backward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end,
|  | const TextIter& | limit |
| ) |  |  | const

Same as gtk_text_iter_forward_search(), but moves backward.

Parameters:

  | str | Search string.
  | flags | Bitmask of flags affecting the search.
  | match_start | Return location for start of match.
  | match_end | Return location for end of match.
  | limit | Location of last possible match_start.

Returns:
  Whether a match was found.

bool Gtk::TextIter::backward_sentence_start | ( |  | ) |

Moves backward to the previous sentence start; if iter is already at the start of a sentence, moves backward to the next one.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_sentence_starts | ( | int | count | ) |

Calls gtk_text_iter_backward_sentence_start() up to count times, or until it returns `false`.

If count is negative, moves forward instead of backward.

Parameters:

  | count | Number of sentences to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_to_tag_toggle | ( | const Glib::RefPtr<TextTag>& | tag | ) |

Moves backward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.

If no matching tag toggles are found, Return value: whether we found a tag toggle before iter

Parameters:

  | tag | A Gtk::TextTag, or `0`.

Returns:
  Whether we found a tag toggle before iter.

bool Gtk::TextIter::backward_visible_cursor_position | ( |  | ) |

Moves iter forward to the previous visible cursor position.

See gtk_text_iter_backward_cursor_position() for details.

Returns:
  `true` if we moved and the new position is dereferenceable

Since gtkmm 2.4:

bool Gtk::TextIter::backward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See gtk_text_iter_backward_cursor_position() for details.

Parameters:

  | count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable

Since gtkmm 2.4:

bool Gtk::TextIter::backward_visible_line | ( |  | ) |

Moves iter to the start of the previous visible line.

Returns `true` if iter could be moved; i.e. if iter was at character offset 0, this function returns `false`. Therefore if iter was already on line 0, but not at the start of the line, iter is snapped to the start of the line and the function returns `true`. (Note that this implies that in a loop calling this function, the line number may not change on every iteration, if your first iteration is on line 0.)

Returns:
  Whether iter moved

Since gtkmm 2.8:

bool Gtk::TextIter::backward_visible_lines | ( | int | count | ) |

Moves count visible lines backward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves forward by 0 - count lines.

Parameters:

  | count | Number of lines to move backward.

Returns:
  Whether iter moved and is dereferenceable

Since gtkmm 2.8:

bool Gtk::TextIter::backward_visible_word_start | ( |  | ) |

Moves backward to the previous visible word start.

(If iter is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator

Since gtkmm 2.4:

bool Gtk::TextIter::backward_visible_word_starts | ( | int | count | ) |

Calls gtk_text_iter_backward_visible_word_start() up to count times.

Parameters:

  | count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator

Since gtkmm 2.4:

bool Gtk::TextIter::backward_word_start | ( |  | ) |

Moves backward to the previous word start.

(If iter is currently on a word start, moves backward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::backward_word_starts | ( | int | count | ) |

Calls gtk_text_iter_backward_word_start() up to count times.

Parameters:

  | count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::begins_tag | ( |  | ) | const

bool Gtk::TextIter::begins_tag | ( | const Glib::RefPtr<const TextTag>& | tag | ) | const

Return value: whether iter is the start of a range tagged with tag.

Parameters:

  | tag | A Gtk::TextTag, or `0`.

Returns:
  Whether iter is the start of a range tagged with tag.

bool Gtk::TextIter::can_insert | ( | bool | default_editability = `true` | ) | const

Considering the default editability of the buffer, and tags that affect editability, determines whether text inserted at iter would be editable.

If text inserted at iter would be editable then the user should be allowed to insert text at iter. Gtk::TextBuffer::insert_interactive() uses this function to decide whether insertions are allowed at a given position.

Parameters:

  | default_editability | `true` if text is editable by default.

Returns:
  Whether text inserted at iter would be editable.

int Gtk::TextIter::compare | ( | const TextIter& | rhs | ) | const

A qsort()-style function that returns negative if lhs is less than rhs, positive if lhs is greater than rhs, and 0 if they're equal.

Ordering is in character offset order, i.e. the first character in the buffer is less than the second character in the buffer.

Parameters:

  | rhs | Another Gtk::TextIter.

Returns:
  -1 if lhs is less than rhs, 1 if lhs is greater, 0 if they are equal.

bool Gtk::TextIter::editable | ( | bool | default_setting = `true` | ) | const

Return value: whether iter is inside an editable range.

Parameters:

  | default_setting | `true` if text is editable by default.

Returns:
  Whether iter is inside an editable range.

bool Gtk::TextIter::ends_line | ( |  | ) | const

Return value: whether iter is at the end of a line.

Returns:
  Whether iter is at the end of a line.

bool Gtk::TextIter::ends_sentence | ( |  | ) | const

Determines whether iter ends a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is at the end of a sentence.

bool Gtk::TextIter::ends_tag | ( |  | ) | const

bool Gtk::TextIter::ends_tag | ( | const Glib::RefPtr<const TextTag>& | tag | ) | const

Return value: whether iter is the end of a range tagged with tag.

Parameters:

  | tag | A Gtk::TextTag, or `0`.

Returns:
  Whether iter is the end of a range tagged with tag.

bool Gtk::TextIter::ends_word | ( |  | ) | const

Determines whether iter ends a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is at the end of a word.

bool Gtk::TextIter::forward_char | ( |  | ) |

Moves iter forward by one character offset.

Note that images embedded in the buffer occupy 1 character slot, so gtk_text_iter_forward_char() may actually move onto an image instead of a character, if you have images in your buffer. If iter is the end iterator or one character before it, iter will now point at the end iterator, and gtk_text_iter_forward_char() returns `false` for convenience when writing loops.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_chars | ( | int | count | ) |

Moves count characters if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the new position of iter is different from its original position, and dereferenceable (the last iterator in the buffer is not dereferenceable). If count is 0, the function does nothing and returns `false`.

Parameters:

  | count | Number of characters to move, may be negative.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_cursor_position | ( |  | ) |

Moves iter forward by a single cursor position.

Cursor positions are (unsurprisingly) positions where the cursor can appear. Perhaps surprisingly, there may not be a cursor position between all characters. The most common example for European languages would be a carriage return/newline sequence. For some Unicode characters, the equivalent of say the letter "a" with an accent mark will be represented as two characters, first the letter then a "combining mark" that causes the accent to be rendered; so the cursor can't go between those two characters. See also the Pango::LogAttr structure and pango_break() function.

Returns:
  `true` if we moved and the new position is dereferenceable.

bool Gtk::TextIter::forward_cursor_positions | ( | int | count | ) |

Moves up to count cursor positions.

See gtk_text_iter_forward_cursor_position() for details.

Parameters:

  | count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable.

template <class Predicate>

bool Gtk::TextIter::forward_find_char | ( | const Predicate & | predicate | ) | `[inline]`

template <class Predicate>

bool Gtk::TextIter::forward_find_char | ( | const Predicate & | predicate,
|  | const TextIter& | limit |
| ) |  |  | `[inline]`

bool Gtk::TextIter::forward_line | ( |  | ) |

Moves iter to the start of the next line.

Returns `true` if there was a next line to move to, and `false` if iter was simply moved to the end of the buffer and is now not dereferenceable, or if iter was already at the end of the buffer.

Returns:
  Whether iter can be dereferenced.

bool Gtk::TextIter::forward_lines | ( | int | count | ) |

Moves count lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves backward by 0 - count lines.

Parameters:

  | count | Number of lines to move forward.

Returns:
  Whether iter moved and is dereferenceable.

bool Gtk::TextIter::forward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end |
| ) |  |  | const

Same as forward_search(), but searchs to the end.

Parameters:

  | str | A search string.
  | flags | Flags affecting how the search is done.
  | match_start | Return location for start of match, or `0`.
  | match_end | Return location for end of match, or `0`.

Returns:
  Whether a match was found.

bool Gtk::TextIter::forward_search | ( | const Glib::ustring & | str,
|  | TextSearchFlags | flags,
|  | TextIter& | match_start,
|  | TextIter& | match_end,
|  | const TextIter& | limit |
| ) |  |  | const

Searches forward for str.

Any match is returned by setting match_start to the first character of the match and match_end to the first character after the match. The search will not continue past limit. Note that a search is a linear or O(n) operation, so you may wish to use limit to avoid locking up your UI on large buffers.

If the Gtk::TEXT_SEARCH_VISIBLE_ONLY flag is present, the match may have invisible text interspersed in str. i.e. str will be a possibly-noncontiguous subsequence of the matched range. similarly, if you specify Gtk::TEXT_SEARCH_TEXT_ONLY, the match may have pixbufs or child widgets mixed inside the matched range. If these flags are not given, the match must be exact; the special 0xFFFC character in str will match embedded pixbufs or child widgets.

Parameters:

  | str | A search string.
  | flags | Flags affecting how the search is done.
  | match_start | Return location for start of match.
  | match_end | Return location for end of match.
  | limit | Bound for the search.

Returns:
  Whether a match was found.

bool Gtk::TextIter::forward_sentence_end | ( |  | ) |

Moves forward to the next sentence end.

(If iter is at the end of a sentence, moves to the next end of sentence.) Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_sentence_ends | ( | int | count | ) |

Calls gtk_text_iter_forward_sentence_end() count times (or until gtk_text_iter_forward_sentence_end() returns `false`).

If count is negative, moves backward instead of forward.

Parameters:

  | count | Number of sentences to move.

Returns:
  `true` if iter moved and is not the end iterator.

void Gtk::TextIter::forward_to_end | ( |  | ) |

Moves iter forward to the "end iterator," which points one past the last valid character in the buffer.

gtk_text_iter_get_char() called on the end iterator returns 0, which is convenient for writing loops.

bool Gtk::TextIter::forward_to_line_end | ( |  | ) |

Moves the iterator to point to the paragraph delimiter characters, which will be either a newline, a carriage return, a carriage return/newline in sequence, or the Unicode paragraph separator character.

If the iterator is already at the paragraph delimiter characters, moves to the paragraph delimiter characters for the next line. If iter is on the last line in the buffer, which does not end in paragraph delimiters, moves to the end iterator (end of the last line), and returns `false`.

Returns:
  `true` if we moved and the new location is not the end iterator.

bool Gtk::TextIter::forward_to_tag_toggle | ( | const Glib::RefPtr<TextTag>& | tag | ) |

Moves forward to the next toggle (on or off) of the Gtk::TextTag tag, or to the next toggle of any tag if tag is `0`.

If no matching tag toggles are found, Return value: whether we found a tag toggle after iter

Parameters:

  | tag | A Gtk::TextTag, or `0`.

Returns:
  Whether we found a tag toggle after iter.

bool Gtk::TextIter::forward_visible_cursor_position | ( |  | ) |

Moves iter forward to the next visible cursor position.

See gtk_text_iter_forward_cursor_position() for details.

Returns:
  `true` if we moved and the new position is dereferenceable

Since gtkmm 2.4:

bool Gtk::TextIter::forward_visible_cursor_positions | ( | int | count | ) |

Moves up to count visible cursor positions.

See gtk_text_iter_forward_cursor_position() for details.

Parameters:

  | count | Number of positions to move.

Returns:
  `true` if we moved and the new position is dereferenceable

Since gtkmm 2.4:

bool Gtk::TextIter::forward_visible_line | ( | int | count | ) |

Moves count visible lines forward, if possible (if count would move past the start or end of the buffer, moves to the start or end of the buffer).

The return value indicates whether the iterator moved onto a dereferenceable position; if the iterator didn't move, or moved onto the end iterator, then `false` is returned. If count is 0, the function does nothing and returns `false`. If count is negative, moves backward by 0 - count lines.

Parameters:

  | count | Number of lines to move forward.

Returns:
  Whether iter moved and is dereferenceable

Since gtkmm 2.8:

bool Gtk::TextIter::forward_visible_line | ( |  | ) |

Moves iter to the start of the next visible line.

Returns `true` if there was a next line to move to, and `false` if iter was simply moved to the end of the buffer and is now not dereferenceable, or if iter was already at the end of the buffer.

Returns:
  Whether iter can be dereferenced

Since gtkmm 2.8:

bool Gtk::TextIter::forward_visible_word_end | ( |  | ) |

Moves forward to the next visible word end.

(If iter is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator

Since gtkmm 2.4:

bool Gtk::TextIter::forward_visible_word_ends | ( | int | count | ) |

Calls gtk_text_iter_forward_visible_word_end() up to count times.

Parameters:

  | count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator

Since gtkmm 2.4:

bool Gtk::TextIter::forward_word_end | ( |  | ) |

Moves forward to the next word end.

(If iter is currently on a word end, moves forward to the next one after that.) Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::forward_word_ends | ( | int | count | ) |

Calls gtk_text_iter_forward_word_end() up to count times.

Parameters:

  | count | Number of times to move.

Returns:
  `true` if iter moved and is not the end iterator.

bool Gtk::TextIter::get_attributes | ( | TextAttributes& | values | ) | const

Glib::RefPtr<TextBuffer> Gtk::TextIter::get_buffer | ( |  | ) | const

Return value: the buffer.

Returns:
  The buffer.

int Gtk::TextIter::get_bytes_in_line | ( |  | ) | const

Return value: number of bytes in the line.

Returns:
  Number of bytes in the line.

gunichar Gtk::TextIter::get_char | ( |  | ) | const

returns 0.

Return value: a Unicode character, or 0 if iter is not dereferenceable

Returns:
  A Unicode character, or 0 if iter is not dereferenceable.

int Gtk::TextIter::get_chars_in_line | ( |  | ) | const

Return value: number of characters in the line.

Returns:
  Number of characters in the line.

Glib::RefPtr<const TextChildAnchor> Gtk::TextIter::get_child_anchor | ( |  | ) | const

If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The anchor at iter.

Glib::RefPtr<TextChildAnchor> Gtk::TextIter::get_child_anchor | ( |  | ) |

If the location at iter contains a child anchor, the anchor is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The anchor at iter.

Pango::Language Gtk::TextIter::get_language | ( |  | ) | const

A convenience wrapper around gtk_text_iter_get_attributes(), which returns the language in effect at iter.

If no tags affecting language apply to iter, the return value is identical to that of gtk_get_default_language().

Returns:
  Language in effect at iter.

int Gtk::TextIter::get_line | ( |  | ) | const

Return value: a line number.

Returns:
  A line number.

int Gtk::TextIter::get_line_index | ( |  | ) | const

Return value: distance from start of line, in bytes.

Returns:
  Distance from start of line, in bytes.

int Gtk::TextIter::get_line_offset | ( |  | ) | const

Return value: offset from start of line.

Returns:
  Offset from start of line.

Glib::SListHandle<Glib::RefPtr<const TextMark>> Gtk::TextIter::get_marks | ( |  | ) | const

Return value: list of Gtk::TextMark.

Returns:
  List of Gtk::TextMark.

Glib::SListHandle<Glib::RefPtr<TextMark>> Gtk::TextIter::get_marks | ( |  | ) |

Return value: list of Gtk::TextMark.

Returns:
  List of Gtk::TextMark.

int Gtk::TextIter::get_offset | ( |  | ) | const

Return value: a character offset.

Returns:
  A character offset.

Glib::RefPtr<Gdk::Pixbuf> Gtk::TextIter::get_pixbuf | ( |  | ) | const

If the element at iter is a pixbuf, the pixbuf is returned (with no new reference count added).

Otherwise, `0` is returned.

Returns:
  The pixbuf at iter.

Glib::ustring Gtk::TextIter::get_slice | ( | const TextIter& | end | ) | const

Return value: slice of text from the buffer.

Parameters:

  | end | Iterator at end of a range.

Returns:
  Slice of text from the buffer.

Glib::SListHandle<Glib::RefPtr<const TextTag>> Gtk::TextIter::get_tags | ( |  | ) | const

Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).

Returns:
  List of Gtk::TextTag.

Glib::SListHandle<Glib::RefPtr<TextTag>> Gtk::TextIter::get_tags | ( |  | ) |

Returns a list of tags that apply to iter, in ascending order of priority (highest-priority tags are last).

Returns:
  List of Gtk::TextTag.

Glib::ustring Gtk::TextIter::get_text | ( | const TextIter& | end | ) | const

Return value: array of characters from the buffer.

Parameters:

  | end | Iterator at end of a range.

Returns:
  Array of characters from the buffer.

Glib::SListHandle<Glib::RefPtr<const TextTag>> Gtk::TextIter::get_toggled_tags | ( | bool | toggled_on = `true` | ) | const

Return value: tags toggled at this point.

Parameters:

  | toggled_on | `true` to get toggled-on tags.

Returns:
  Tags toggled at this point.

Glib::SListHandle<Glib::RefPtr<TextTag>> Gtk::TextIter::get_toggled_tags | ( | bool | toggled_on = `true` | ) |

Return value: tags toggled at this point.

Parameters:

  | toggled_on | `true` to get toggled-on tags.

Returns:
  Tags toggled at this point.

int Gtk::TextIter::get_visible_line_index | ( |  | ) | const

Return value: byte index of iter with respect to the start of the line.

Returns:
  Byte index of iter with respect to the start of the line.

int Gtk::TextIter::get_visible_line_offset | ( |  | ) | const

Return value: offset in visible characters from the start of the line.

Returns:
  Offset in visible characters from the start of the line.

Glib::ustring Gtk::TextIter::get_visible_slice | ( | const TextIter& | end | ) | const

Like gtk_text_iter_get_slice(), but invisible text is not included.

Invisible text is usually invisible because a Gtk::TextTag with the "invisible" attribute turned on has been applied to it.

Parameters:

  | end | Iterator at end of range.

Returns:
  Slice of text from the buffer.

Glib::ustring Gtk::TextIter::get_visible_text | ( | const TextIter& | end | ) | const

Like gtk_text_iter_get_text(), but invisible text is not included.

Invisible text is usually invisible because a Gtk::TextTag with the "invisible" attribute turned on has been applied to it.

Parameters:

  | end | Iterator at end of range.

Returns:
  String containing visible text in the range.

const GtkTextIter* Gtk::TextIter::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C instance.

References Glib::ValueBase::gobject_.

GtkTextIter* Gtk::TextIter::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C instance.

References Glib::ValueBase::gobject_.

bool Gtk::TextIter::has_tag | ( |  | ) | const

bool Gtk::TextIter::has_tag | ( | const Glib::RefPtr<const TextTag>& | tag | ) | const

Return value: whether iter is tagged with tag.

Parameters:

  | tag | A Gtk::TextTag.

Returns:
  Whether iter is tagged with tag.

bool Gtk::TextIter::in_range | ( | const TextIter& | start,
|  | const TextIter& | end |
| ) |  |  | const

Checks whether iter falls in the range [ start, end).

start and end must be in ascending order.

Parameters:

  | start | Start of range.
  | end | End of range.

Returns:
  `true` if iter is in the range.

bool Gtk::TextIter::inside_sentence | ( |  | ) | const

Determines whether iter is inside a sentence (as opposed to in between two sentences, e.g. after a period and before the first letter of the next sentence).

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is inside a sentence.

bool Gtk::TextIter::inside_word | ( |  | ) | const

Determines whether iter is inside a natural-language word (as opposed to say inside some whitespace).

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is inside a word.

bool Gtk::TextIter::is_cursor_position | ( |  | ) | const

See gtk_text_iter_forward_cursor_position() or Pango::LogAttr or pango_break() for details on what a cursor position is.

Returns:
  `true` if the cursor can be placed at iter.

bool Gtk::TextIter::is_end | ( |  | ) | const

Return value: whether iter is the end iterator.

Returns:
  Whether iter is the end iterator.

bool Gtk::TextIter::is_start | ( |  | ) | const

Return value: whether iter is the first in the buffer.

Returns:
  Whether iter is the first in the buffer.

Gtk::TextIter::operator bool | ( |  | ) | const`[inline]`

Alias for !is_end().

value_type Gtk::TextIter::operator* | ( |  | ) | const`[inline]`

Alias for get_char().

const TextIter Gtk::TextIter::operator++ | ( | int |  | ) | `[inline]`

TextIter& Gtk::TextIter::operator++ | ( |  | ) | `[inline]`

Alias for forward_char().

const TextIter Gtk::TextIter::operator-- | ( | int |  | ) | `[inline]`

TextIter& Gtk::TextIter::operator-- | ( |  | ) | `[inline]`

Alias for backward_char().

void Gtk::TextIter::order | ( | TextIter& | second | ) |

Swaps the value of first and second if second comes before first in the buffer.

That is, ensures that first and second are in sequence. Most text buffer functions that take a range call this automatically on your behalf, so there's no real reason to call it yourself in those cases. There are some exceptions, such as gtk_text_iter_in_range(), that expect a pre-sorted range.

Parameters:

  | second | Another Gtk::TextIter.

void Gtk::TextIter::set_line | ( | int | line_number | ) |

Moves iterator iter to the start of the line line_number.

If line_number is negative or larger than the number of lines in the buffer, moves iter to the start of the last line in the buffer.

Parameters:

  | line_number | Line number (counted from 0).

void Gtk::TextIter::set_line_index | ( | int | byte_on_line | ) |

Same as gtk_text_iter_set_line_offset(), but works with a byte index.

The given byte index must be at the start of a character, it can't be in the middle of a UTF-8 encoded character.

Parameters:

  | byte_on_line | A byte index relative to the start of iter's current line.

void Gtk::TextIter::set_line_offset | ( | int | char_on_line | ) |

Moves iter within a line, to a new character (not byte) offset.

The given character offset must be less than or equal to the number of characters in the line; if equal, iter moves to the start of the next line. See gtk_text_iter_set_line_index() if you have a byte index rather than a character offset.

Parameters:

  | char_on_line | A character offset relative to the start of iter's current line.

void Gtk::TextIter::set_offset | ( | int | char_offset | ) |

Sets iter to point to char_offset.

char_offset counts from the start of the entire text buffer, starting with 0.

Parameters:

  | char_offset | A character number.

void Gtk::TextIter::set_visible_line_index | ( | int | byte_on_line | ) |

Like gtk_text_iter_set_line_index(), but the index is in visible bytes, i.e. text with a tag making it invisible is not counted in the index.

Parameters:

  | byte_on_line | A byte index.

void Gtk::TextIter::set_visible_line_offset | ( | int | char_on_line | ) |

Like gtk_text_iter_set_line_offset(), but the offset is in visible characters, i.e. text with a tag making it invisible is not counted in the offset.

Parameters:

  | char_on_line | A character offset.

bool Gtk::TextIter::starts_line | ( |  | ) | const

Return value: whether iter begins a line.

Returns:
  Whether iter begins a line.

bool Gtk::TextIter::starts_sentence | ( |  | ) | const

Determines whether iter begins a sentence.

Sentence boundaries are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango text boundary algorithms).

Returns:
  `true` if iter is at the start of a sentence.

bool Gtk::TextIter::starts_word | ( |  | ) | const

Determines whether iter begins a natural-language word.

Word breaks are determined by Pango and should be correct for nearly any language (if not, the correct fix would be to the Pango word break algorithms).

Returns:
  `true` if iter is at the start of a word.

bool Gtk::TextIter::toggles_tag | ( |  | ) | const

bool Gtk::TextIter::toggles_tag | ( | const Glib::RefPtr<const TextTag>& | tag | ) | const

This is equivalent to (gtk_text_iter_begins_tag() || gtk_text_iter_ends_tag()), i.e. it tells you whether a range with tag applied to it begins or ends at iter.

Parameters:

  | tag | A Gtk::TextTag, or `0`.

Returns:
  Whether tag is toggled on or off at iter.

## Friends And Related Function Documentation

bool operator!= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

bool operator< | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

bool operator<= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

bool operator== | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

bool operator> | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

bool operator>= | ( | const TextIter& | lhs,
|  | const TextIter& | rhs |
| ) |  |  | `[related]`

Parameters:

  | lhs | The left-hand side
  | rhs | The right-hand side

Returns:
  The result

const Gtk::TextIter& wrap | ( | const GtkTextIter * | object | ) | `[related]`

Parameters:

  | object | The C instance

Returns:
  A C++ instance that wraps this C instance.

Gtk::TextIter& wrap | ( | GtkTextIter * | object | ) | `[related]`

Parameters:

  | object | The C instance

Returns:
  A C++ instance that wraps this C instance.

## Member Data Documentation

GtkTextIter Gtk::TextIter::gobject_`[protected]`

The documentation for this class was generated from the following file:

- textiter.h